import { io } from "socket.io-client";
import store from "./store";
import { setRoomCode } from "./store/socketSlice";
import { addContestant } from "./store/displaySlice";
import { addCategory } from "./store/cluesSlice";

export const socket = io(`${window.location.hostname}:5000`);

export const setup = () => {
  socket.on("connect", () => {
    console.log("Connected to socket");
  });

  socket.on("set-code", ({ code }: { code: string }) => {
    store.dispatch(setRoomCode(code));
  });

  socket.on(
    "contestant-joined",
    (data: { sid: string; signature: number[][] }) => {
      store.dispatch(addContestant(data));
    }
  );

  socket.on("categories", (data: string[]) =>
    data.forEach((category) => store.dispatch(addCategory(category)))
  );
};
