import { createSlice, PayloadAction } from "@reduxjs/toolkit";
import type { RootState } from "./";

interface Category {
  name: string;
  clues: Clue[];
}

interface Clue {
  value: number;
  question: string;
  answer?: string;
}

const initialState: Category[] = [];

export const cluesSlice = createSlice({
  name: "clues",
  initialState,
  reducers: {
    addCategory: (state, { payload }: PayloadAction<string>) =>
      (state = [...state, { name: payload, clues: [] }]),
  },
});

export const { addCategory } = cluesSlice.actions;
export const selectCategories = (state: RootState) => state.clues;

export default cluesSlice.reducer;
